OpenVDB 13.0.0

Loading...
Searching...
No Matches
SparseStencilMatrix< ValueType_, STENCIL_SIZE >::ConstRow Class Reference

Read-only accessor to a row of this matrix. More...

`#include <openvdb/math/ConjGradient.h>`

Inheritance diagram for SparseStencilMatrix< ValueType_, STENCIL_SIZE >::ConstRow:

## Public Types
using | DataType

## Public Member Functions
| ConstRow (const ValueType *valueHead, const SizeType *columnHead, const SizeType &rowSize)
bool | empty () const
const SizeType & | size () const
const ValueType & | getValue (SizeType columnIdx, bool &active) const
const ValueType & | getValue (SizeType columnIdx) const
ConstValueIter | cbegin () const
| Return an iterator over the stored values in this row.
bool | eq (const RowBase< OtherDataType > &other, ValueType eps=Tolerance< ValueType >::value()) const
| Return `true` if this row is equivalent to the given row to within the specified tolerance.
VecValueType | dot (const VecValueType *inVec, SizeType vecSize) const
| Return the dot product of this row with the first vecSize elements of inVec.
VecValueType | dot (const Vector< VecValueType > &inVec) const
| Return the dot product of this row with the given vector.
std::string | str () const
| Return a string representation of this row.

## Static Public Member Functions
static SizeType | capacity ()

## Protected Member Functions
const ValueType & | value (SizeType i) const
SizeType | column (SizeType i) const
SizeType | find (SizeType columnIdx) const
| Return the array index of the first column index that is equal to or greater than the given column index.

## Protected Attributes
DataType | mData

## Detailed Description

template<typename ValueType_, SizeType STENCIL_SIZE>
class openvdb::v13_0::math::pcg::SparseStencilMatrix< ValueType_, STENCIL_SIZE >::ConstRow

Read-only accessor to a row of this matrix.

## Member Typedef Documentation

## ◆ DataType

using DataType
| inherited

## Constructor & Destructor Documentation

## ◆ ConstRow()

template<typename ValueType, SizeType STENCIL_SIZE>

ConstRow | ( | const ValueType * | valueHead,
|  | const SizeType * | columnHead,
|  | const SizeType & | rowSize )
| inline

## Member Function Documentation

## ◆ capacity()

SizeType capacity | ( |  | ) |
| inline static inherited

## ◆ cbegin()

ConstValueIter cbegin | ( |  | ) | const
| inherited

Return an iterator over the stored values in this row.

## ◆ column()

SizeType column | ( | SizeType | i | ) | const
| inline protected inherited

## ◆ dot() [1/2]

VecValueType dot | ( | const Vector< VecValueType > & | inVec | ) | const
| inherited

Return the dot product of this row with the given vector.

## ◆ dot() [2/2]

VecValueType dot | ( | const VecValueType * | inVec,
|  | SizeType | vecSize ) const
| inherited

Return the dot product of this row with the first vecSize elements of inVec.

Warning
  inVec must have at least vecSize elements.

## ◆ empty()

bool empty | ( |  | ) | const
| inline inherited

## ◆ eq()

bool eq | ( | const RowBase< OtherDataType > & | other,
|  | ValueType | eps = Tolerance<ValueType>::value() ) const
| inherited

Return `true` if this row is equivalent to the given row to within the specified tolerance.

## ◆ find()

SizeType find | ( | SizeType | columnIdx | ) | const
| protected inherited

Return the array index of the first column index that is equal to or greater than the given column index.

Note
  If columnIdx is larger than any existing column index, the return value will point beyond the end of the array.

## ◆ getValue() [1/2]

const ValueType & getValue | ( | SizeType | columnIdx | ) | const
| inherited

## ◆ getValue() [2/2]

const ValueType & getValue | ( | SizeType | columnIdx,
|  | bool & | active ) const
| inherited

## ◆ size()

const SizeType & size | ( |  | ) | const
| inline inherited

## ◆ str()

std::string str | ( |  | ) | const
| inherited

Return a string representation of this row.

## ◆ value()

const ValueType & value | ( | SizeType | i | ) | const
| inline protected inherited

## Member Data Documentation

## ◆ mData

DataType mData
| protected inherited